{$X+,V-,B-,I-}
Program IPXSEND;

{$DEFINE noTRACE}

uses dos,crt;

CONST IOSocket=$5678;           { socket to transmit/receive on }
      PEP_PACKET_TYPE       =4;  { Packet Exchange Protocol   }
      IPX_NOT_INSTALLED               = 240; {nwIpx}
    SHORT_LIVED_SOCKET = FALSE;

Type      TnetworkAddress=array[1..4] of byte; { hi-endian }
     TnodeAddress   =array[1..6] of byte; { Hi-endian }
     TinterNetworkAddress=record
                          net   :TnetworkAddress; {hi-lo}
                          node  :Tnodeaddress;    {hi-lo}
                          socket:word;            {lo-hi}
                          end;
Type TipxHeader=Record
                checksum         :word; { not used, set to $FFFF }
                length           :word; { total number of bytes }
                TransportControl :byte; { used by bridges: low 4 bits= hop count
}
                packetType       :byte; { ignored by IPX, used by higher level
                                          protocols only. $00=unknown packet
type}
                destination,
                source           :TinternetWorkAddress;
                                         { if dest.network equals 0; dest
                                           assumed on same network as sender }
                                         { if dest.node =$FFFFFFFFFFFF, packet
                                           will be sent to all nodes. }
                end;
    { Fields within IPX and SPX are high-low. Byte swapping will be done
      by the IPX functions, except network and node addresses. }

    Tfragment=record { address and size of buffer fragment. }
              Address:Pointer;
              Size:word;
              end;

    Tecb=record
         Linkaddress     :Pointer; { used by IPX itself }
         ESRaddress      :Pointer;
         InUseFlag       :Byte; { reset to $00 when request completed }
         CompletionCode  :Byte; { valid after InUseFlag becomes $00;
                                 completionCode=$00: packet sent/received. }
         SocketNumber    :word;
         IPXworkspace    :array[1..4] of byte;
         DriverWorkspace :array[1..12] of byte;
         Immediateaddress:Tnodeaddress; { 6 bytes }
         FragmentCount   :word;  { must be >0 }
         Fragment        :array[1..2] of Tfragment; { [1..FragmentCount] }
                          { The number of fragments is unlimited.
                            However, most applications use 1 or 2. }
         end;
    Tpecb=^Tecb;

{    TAESecb=:
Offset  Size    Description
 00h    DWORD   Link
 04h    DWORD   ESR address
 08h    BYTE    in use flag (see below)
 09h  5 BYTEs   AES workspace }

 Type TpepHeader=Record
               IPXhdr       :TipxHeader;  { set packettype to $04 }
               TransactionID:Longint;
               clientType   :word;
               end;


Var ListenECB     :Tecb;        { ECB and header, to listen for acknowledgement
}
    ListenPepHdr  :TpepHeader;

    SendECB       :Tecb;        { ECB and header, used to send the data }
    SendPepHdr    :TpepHeader;

    socket        :word;

    SendDataBuffer  :array[1..546] of byte; { SendDataBufferfer for data to be
sent }

    ListenDataBuffer:array[1..8] of byte;

    AckReceived   :boolean;     { set to true within the ListenForAckESR }

    SendTransId   :LongInt;     { transactionID. This uniquely identifies
                                  the packet. The slave/receiver has to
                                  reply with the same transactionID in the
                                  header of the acknowledgement. Only if
                                  this number is the same as the transactioID
                                  of the sent packet, the pavket is considered
                                  successfully delivered. }

    NewStack:array[1..1024] of word;  { !! used by ESR }
    StackBottom:word;                 { !! used by ESR }

    f:file;

Var IpxSpxCall:Procedure;

Var Result:word; { unit errorcode variable }

Procedure IpxSpxSystemCall(Var regs:registers); assembler;
{ This method of calling IPX/SPX is preferred by Novell. }
{ For what its' worth: this call is 48 bytes longer than the other one.. }
asm
   { check if IpxSpxCall known. If not, return error $FF in fake AL }
xor ah,ah
mov al,$FF
les di,IpxSpxCall
mov bx,es
cmp bx,$0000
je  @1
   { move fake regs registers to 'real' registers }
   { AX, BX, CX, DX, SI, DI, ES only. }
les di,regs
mov ax,es:[di+16]
push ax            { push new es }
mov ax,es:[di+12]
push ax            { push new di }
mov ax,es:[di]
mov bx,es:[di+2]
mov cx,es:[di+4]
mov dx,es:[di+6]
mov si,es:[di+10]
pop di
pop es
   { farr call to A7 interrup handler }
push bp
CALL IpxSpxCall
pop bp
@1: { move 'real' registers to fake regs registers }
push es
push di
les di,regs
mov es:[di],ax
mov es:[di+2],bx
mov es:[di+4],cx
mov es:[di+6],dx
mov es:[di+10],si
pop ax             { ax:= 'di' }
mov es:[di+12],ax
pop ax             { ax:= 'es' }
mov es:[di+16],ax
end;

{IPX: 00}
Function IPXOpenSocket(Var socket:word; permanentSocket:boolean):boolean;
Var regs:registers;
    reqForSocket:boolean;
begin
regs.bx:=$0000;
if permanentSocket
 then regs.al:=$FF
 else regs.al:=$00;
regs.dx:=swap(socket); {hi-lo}
reqForSocket:=(socket=$0000);

IpxSpxSystemCall(Regs);

result:=regs.al;
if reqForSocket
 then socket:=swap(regs.dx); {force lo-hi}
IPXopenSocket:=(result=0);
{ resultcodes: $00 successful; $FE Socket Table Is Full;
               $FF socket already open OR IPX not initilazed. }
end;

{IPX: 01}
Function IPXCloseSocket(socket:word):boolean;
Var regs:registers;
begin
regs.bx:=$01;
regs.dx:=swap(socket);
IpxSpxSystemCall(regs);
result:=regs.al;
if result<>$FF then result:=$00;
IPXCloseSocket:=(result=$00);
{ possible resultcodes: $00 Successful; $FF IPX not initialized }
end;

Procedure CheckError(err:boolean; errNbr:word);
begin
if err
 then begin
      writeln;
      CASE errNbr of
       $0100:writeln('IPX needs to be installed.');
       $0200:writeln('Error: can''t locate the spcified username.');
       $0201:begin
              writeln('The specified user has multiple connections.');
              writeln('This demonstation program doesn''t support multiple connections.');
              end;
       $0202:writeln('Error: can''t find the address of the supplied username.');
       $0204:writeln('Transfer aborted after 50 retries.');
       $0205:writeln('Key pressed: Transfer aborted.');
       $0206:writeln('The supplied file couldn''t be found. Please supply full path.');
       $0300:writeln('Error reading file.');
       $10FE:writeln('Error opening socket: Socket Table Is Full.');
       $10FF:writeln('Error opening socket: Socket is already open.');
      end; {case}
      IPXcloseSocket(IOsocket);
      close(f);
      halt(1);
      end;
end;

Function TimeOut(t1,t2:word;n:byte):boolean;
{ ticks t2 - ticks t1 > n seconds ? }
Var lt1,lt2:LongInt;
begin
lt2:=t2;
if t1>t2 then lt2:=lt2+$FFFF;
TimeOut:=(lt2-t1)>(n*18);
end;

Function IPXSendPacket(Var Ecb:Tecb):boolean;
{ the ecb must be filled, before calling this function }
{ Right after this call, IPXrelinquishControl should be called Iteratively,
  this allows the sending of the IPX packet. }
Var regs:Registers;
begin
regs.bx:=$0003;
regs.es:=seg(ecb);
regs.si:=ofs(ecb);
IpxSpxSystemCall(Regs);
result:=regs.al;
if result<>$FF then result:=$00;
IpxSendPacket:=(result=$00);
{ possible resultcodes: $00 Successful; $FF IPX not initialized }
end;

Function IPXInternalSendPacket(Var Ecb:Tecb):boolean;
Var regs:Registers;
begin
regs.bx:=$000F;
regs.es:=seg(ecb);
regs.si:=ofs(ecb);
IpxSpxSystemCall(Regs);
result:=regs.al;
if result<>$FF then result:=$00;
IpxInternalSendPacket:=(result=$00);
{ possible resultcodes: $00 Successful; $FF IPX not initialized }
end;

Function IPXListenForPacket(Var Ecb:Tecb):Boolean;
{ socket must be opened, ECB (partly) filled. }
Var regs:Registers;
begin
regs.bx:=$0004;
regs.es:=seg(ecb);
regs.si:=ofs(ecb);
IpxSpxSystemCall(Regs);
result:=regs.al;
if result<>$FF
 then result:=$00;
IpxListenForPacket:=(result=$00);
{resultcodes: $00 Successful;
              $FF Listening Socket doesn't exist OR IPX not initialized }
end;

Function IPXrelinquishControl:boolean;
Var regs:Registers;
begin
regs.bx:=$000A;
IpxSpxSystemCall(Regs);
result:=regs.al;
if result<>$FF then result:=$00;
IpxrelinquishControl:=(result=$00);
{resultcodes: $00 Successful; $FF IPX not initialized }
end;

{$F+}
Procedure ListenForAckHandler(Var p:TPecb);
 { Interrupts are turned off -and should remain turned off- }
begin
IF (ListenECB.CompletionCode<>0)                      { packet must be
suucessfully received.. }
 or (ListenPepHdr.IPXhdr.packetType<>PEP_PACKET_TYPE) { of type PEP.. }
 or (ListenPepHdr.ClientType<>$EA)                    { of client type $EA }
 or (ListenPepHdr.TransactionID<>SendTransId)         { with a correct clientID
(of the packet the master sent) }
  then IPXListenForPacket(ListenECB)   { Invalid packet => listen again   }
  else AckReceived:=true;              { valid packet   => ACK received ! }
end;
{$F-}

{$F+}
Procedure ListenForAckESR; assembler;
asm { ES:SI are the only valid registers when entering this procedure ! }
    { interrupts are turned off -and should remain turned off- }
    mov dx, seg stackbottom
    mov ds, dx

    mov dx,ss  { setup of a new local stack }
    mov bx,sp  { ss:sp copied to dx:bx}
    mov ax,ds
    mov ss,ax
    mov sp,offset stackbottom
    push dx    { push old ss:sp on new stack }
    push bx

    push es    { push es:si on stack as local vars }
    push si
    mov  di,sp

    push ss    { push address of local ptr on stack }
    push di
    CALL ListenForAckHandler

    add sp,4   { skip stack ptr-copy }
    pop bx     { restore ss:sp from new stack }
    pop dx
    mov sp,bx
    mov ss,dx
end;
{$F-}

Function IPXinitialize:Boolean;
CONST DOS_MULTIPLEX =$2F;
Var regs:registers;
begin
Regs.AX:=$7A00;
INTR(DOS_MULTIPLEX,Regs);
if regs.AL<>$FF
 then begin
      Result:=IPX_NOT_INSTALLED;
      IpxInitialize:=false
      end
 else begin
      @IpxSpxCall:=Ptr(Regs.es,Regs.di);
      Result:=0;
      IpxInitialize:=true;
      end;
end;

Procedure PEPSetupListenECB(ESRptr:Pointer;ReceiveSocket:word;
                            BufPtr:Pointer;BufSize:word;
                     {out:} Var PepHdr:TpepHeader; Var ecb:Tecb);
{ Clears IPXheader and ECB, sets values of the required fields within
  the ecb and IPX header. }
{ ECB: ESR adress field, socket number, fragment count, frag.descriptor fields }
begin
FillChar(ecb,SizeOf(Tecb),#0);
FillChar(pepHdr,SizeOF(TpepHeader),#0);
WITH ECB
 do begin
    if ESRptr<>NIL
     then ESRaddress:=ESRptr;
    Fragmentcount:=2;
    socketNumber:=swap(ReceiveSocket); {hi-lo}

    Fragment[1].Address:=@pepHdr;
    Fragment[2].Address:=BufPtr;
    Fragment[1].size:=SizeOf(Tpepheader);
    Fragment[2].size:=BufSize;
    end;
end;

{IPX: 02}
Function IPXGetLocalTarget(Address:TinternetworkAddress;
                           Var ImmAddr:TnodeAddress;
                           VAR ticks:Word               ):boolean;
{ Ticks = estimated transmission time, in number of ticks (1/18 sec) }
Var reqAddr:TinternetworkAddress;
    repNode:TnodeAddress;
    Regs   :registers;
begin
move(Address,reqAddr,10);
reqAddr.socket:=swap(Address.socket); {hi-lo}
With regs
 do begin
    bx:=$0002;
    es:=seg(reqAddr); si:=ofs(reqAddr); di:=ofs(repNode);
    IpxSpxSystemCall(regs);
    ticks:=regs.cx;
    result:=regs.al;
    if result=0
     then move(repNode,ImmAddr,6);
    end;
IPXGetLocalTarget:=(result=$00);
{ resultcodes: $00 Successful; $FA No path to destination node found;
               $FF IPX not initialized. }
end;

Procedure PEPsetupSendECB(ESRptr:pointer; SourceSocket:word;
                          DestAddr:TinterNetworkAddress;
                          BufPtr:pointer; BufSize:word;
                   {out:} Var PepHdr:TpepHeader; Var ecb:Tecb);
{ Clears IPXheader and ECB, sets values of the required fields within
  the ecb and IPX header. }
Var ImmAddr:TnodeAddress;
    Ticks:word;
begin
fillchar(pepHdr,SizeOf(TpepHeader),#0);
with pepHdr.IPXhdr
 do begin
    PacketType:=PEP_PACKET_TYPE;
    Move(DestAddr,Destination,10);
    destination.socket:=swap(DestAddr.socket); {hi-lo}
    end;
IPXGetLocalTarget(DestAddr,ImmAddr,Ticks);
fillchar(ecb,sizeOf(ecb),#0);
With ecb
 do begin
    if ESRptr<>NIL
     then ESRaddress:=ESRptr;
    socketNumber:=swap(SourceSocket); {hi-lo}
    Move(ImmAddr,ImmediateAddress,6);
    FragmentCount:=2;
    fragment[1].Address:=@pephdr;
    fragment[1].size:=SizeOf(TpepHeader);
    fragment[2].Address:=BufPtr;
    fragment[2].size:=BufSize;
    end;
end;

Function IPXgetIntervalMarker(Var ticks:word):boolean;
Var regs:Registers;
begin
regs.bx:=$0008;
IpxSpxSystemCall(Regs);
ticks:=regs.ax;
result:=$00;
IPXgetIntervalMarker:=True;
end;

Function IPXcancelEvent(ECB:Tecb):boolean;
Var regs:registers;
begin
regs.bx:=$0006;
regs.es:=seg(ecb);
regs.si:=ofs(ecb);
IpxSpxSystemCall(Regs);
result:=regs.al;
IPXcancelEvent:=(result=0);
{ resultcodes: 00 Successful; F9 ECB cannot be canceled;
               FF ECB not in use OR IPX not initialized. }
end;

Var dest:TinternetworkAddress;
    ticks,ticks2:word;
    retries     :word;

    Uname,Fname:string;
    NbrOfConn:byte;

    t,p:byte;
    FileInfo:searchrec;
    FileSize:LongInt;
    BytesRead:word;

    TransferStartTicks,TransferEndTicks:word;
    OriginalFileSize:LongInt;

begin
If (paramcount<>1)
 then begin
      writeln;
      writeln('Usage: IPXSEND <filename>');
      writeln;
      writeln('- The file will be sent to all workstations on the network.');
      writeln('- Run IPXGET on the other workstations to receive the file.');
      halt(1);
      end;

NbrOfConn:=0;

  FOR T:=1 TO 4 DO Dest.Net[T]  := $00; { this net/segments }
  FOR T:=1 TO 6 DO Dest.Node[T] := $FF; { all nodes !! }
                   Dest.Socket := IOsocket;

Fname:=ParamStr(1);
Assign(f,Fname);
Reset(f,1);
CheckError(IOresult<>0,$0206);

IpxInitialize;
CheckError(result>0,$0100);

socket:=IOSocket;
IPXopenSocket(Socket,SHORT_LIVED_SOCKET);
CheckError(result>0,$1000+result);

{ setup listening for ack }
AckReceived:=False;

PEPsetupListenECB(Addr(ListenForAckESR),IOsocket,@ListenDataBuffer,8,
                  ListenPepHdr,ListenECB);
IPXListenForPacket(ListenECB);

{ send initial packet with the name and size of the file to be sent. }
findfirst(Fname,$FF,FileInfo);
Move(FileInfo.size,SendDataBuffer[16],4);
FileSize:=Fileinfo.size;
p:=length(Fname);
while (p>0) and (Fname[p]<>':') and (Fname[p]<>'\')
 do dec(p);
If p>0
 then delete (Fname,1,p);
Move(Fname[0],SendDataBuffer[1],15);

PEPsetupSendECB(NIL,IOsocket,dest,@SendDataBuffer[1],512,
                SendPepHdr,SendECB);
SendTransID:=1;
SendPepHdr.ClientType:=$EA;

OriginalFileSize:=FileSize;
FileSize:=FileSize+512; { compensate length for information header }

writeln('IPXSEND waiting for remote handshake. (any key to abort)');

While Filesize>0
 do begin
    ackreceived:=false;
    SendPepHdr.TransactionId:=SendTransId;
    IPXsendPacket(SendECB);
    {$IFDEF TRACE}
    write('Packet#',SendTransID,' sent.');
    {$ENDIF}
    while sendECB.InuseFlag<>0
     do IPXrelinquishControl;

    IPXGetIntervalMarker(ticks);
    retries:=0;
    REPEAT
      IPXrelinquishcontrol;
      IPXGetIntervalMarker(ticks2);
      if (ticks2-ticks)>2
       then begin
            inc(retries);
            {$IFDEF TRACE}
            writeln;
            write('Timeout: resending packet#',SendTransID);
            {$ENDIF}
            IPXsendPacket(SendECB);
            while sendECB.InuseFlag<>0
             do IPXrelinquishControl;
            IPXGetIntervalMarker(ticks);
            end;
      CheckError(retries>50,$0204);
      CheckError(Keypressed,$0205);
    UNTIL AckReceived;
    if SendTransID=1
     then begin
          writeln('Handshake received. Starting file transfer.');
          IPXGetIntervalMarker(TransferStartTicks);
          end;
    {$IFDEF TRACE}
    writeln(' Ackn.#',ListenPepHdr.TransactionID,' received.');
    {$ENDIF}
    FileSize:=FileSize-512;

    { fill buffer with next block of data }
    IF FileSize>0
     then begin
          BlockRead(f,SendDataBuffer,512,bytesread);
          CheckError((bytesread<512) and (filesize<>bytesread),$0300);
          end;

    inc(SendTransID);
    IPXListenForPacket(ListenECB); { start listening for acks again }
    end;
IPXGetIntervalMarker(TransferEndTicks);
IPXcancelEvent(ListenECB);
Writeln('Transfer completed.');
writeln('Throughput: ',
18*OriginalFileSize/(TransferEndTicks-TransferStartTicks):4:2,' bps');
IPXcloseSocket(IOsocket);
close(f);

end.
